<template>
  <div class="building">
    <div class="building-top" :class="`building-top--${building.top}`"></div>

    <div
      v-if="building.parkingFloorsTop"
      class="floor"
      :style="floorStyle()"
      :class="[
        `floor--${$options.filters.floorName(f.displayNum || f.num)}`,
        `floor--wall-${f.wall}`
      ]"
      v-for="f in building.parkingFloors"
    >
      <div class="floor-content">
        <div class="floor-label">
          {{ f.displayNum || f.num | floorName }}
        </div>
        <div class="floor-restaurants">
          <div class="floor-restaurant floor-parking-item"></div>
          <span class="floor-restaurant invisible"></span>
          <span class="floor-restaurant invisible"></span>
          <span class="floor-restaurant invisible"></span>
        </div>
      </div>
      <div
        v-if="f.bridge"
        class="floor-bridge"
        :class="`floor-bridge--${f.bridge}`"
      ></div>
    </div>

    <div
      class="floor"
      :style="floorStyle(f.num)"
      :class="[
        `floor--${$options.filters.floorName(f.displayNum || f.num)}`,
        `floor--wall-${f.wall}`,
        `floor--bg-${f.bg}`
      ]"
      v-for="f in floors"
    >
      <div class="floor-content">
        <div class="floor-label">
          {{ f.displayNum || f.num | floorName }}
        </div>
        <div class="floor-restaurants" v-if="f.parking">
          <div class="floor-restaurant floor-parking-item"></div>
          <span class="floor-restaurant invisible"></span>
          <span class="floor-restaurant invisible"></span>
          <span class="floor-restaurant invisible"></span>
        </div>
        <div class="floor-restaurants" v-else>
          <router-link
            :key="r.id"
            v-for="r in floorRestaurants(f.num)"
            class="floor-restaurant"
            :style="{
              'background-image': `url('${r.logoXS}')`,
              'background-color': r.company.webBannerBackgroundColor
            }"
            :to="{
              name: 'RestaurantBooking',
              params: { groupId: r.groupId, companyId: r.company.id, id: r.id },
              query: { listType: 'floor plan logo' }
            }"
          >
          </router-link>
          <span
            :key="index"
            v-for="index in floorInvisibleRestaurants(f.num)"
            class="floor-restaurant invisible"
          >
          </span>
        </div>
      </div>
      <div
        v-if="f.bridge"
        class="floor-bridge"
        :class="`floor-bridge--${f.bridge}`"
      ></div>
    </div>

    <div
      v-if="!building.parkingFloorsTop"
      :style="floorStyle()"
      class="floor floor--parking floor--wall-basement"
    >
      <div class="floor-content">
        <div class="floor-label">
          B{{ floorsUnderGroundCount - parkingFloorsCount + 1 }}
          <span v-if="parkingFloorsCount > 1">
            <br />
            B{{ floorsUnderGroundCount }}
          </span>
        </div>
        <div class="floor-restaurants">
          <div class="floor-restaurant floor-parking-item"></div>
          <span class="floor-restaurant invisible"></span>
          <span class="floor-restaurant invisible"></span>
          <span class="floor-restaurant invisible"></span>
        </div>
      </div>
    </div>

    <div
      class="floor floor--wall-basement floor--bottom"
      v-for="floor in paddingBottom"
      :style="floorStyle()"
    >
      <div class="floor-content">
        <div class="floor-restaurants">
          <span class="floor-restaurant invisible"></span>
        </div>
      </div>
    </div>

    <div class="floor floor--wall-basement floor--bottom">
      <div class="floor-content">
        {{ building.name }}
      </div>
    </div>
  </div>
</template>
<script>
import _ from "underscore";

export default {
  props: {
    building: {
      required: true
    },
    restaurants: {
      required: true,
      type: Array
    }
  },

  data() {
    return {
      refAvailable: false
    };
  },

  computed: {
    floors() {
      return _.sortBy(
        this.groundFloors.concat(this.basementFloors),
        "num"
      ).reverse();
    },
    groundFloors() {
      return this.building.groundFloors;
    },
    groundFloorsCount() {
      return this.groundFloors.length;
    },
    basementFloors() {
      return this.building.basementFloors;
    },
    paddingBottom() {
      var count = this.building.paddingBottom;
      const floor = [];
      while (count--) {
        floor.push(count);
      }
      return floor;
    },
    parkingFloors() {
      return this.building.parkingFloors;
    },
    parkingFloorsCount() {
      return this.parkingFloors.length;
    },
    floorsUnderGroundCount() {
      const { parkingFloors, basementFloors } = this.building;
      return parkingFloors.length + basementFloors.length;
    },
    businessFloorsCount() {
      const { basementFloors, groundFloors } = this;
      return basementFloors.length + groundFloors.length;
    },
    floorToRestaurants() {
      return _.groupBy(this.restaurants, "floor");
    }
  },
  methods: {
    floorRestaurants(floor) {
      return this.floorToRestaurants[floor] || [];
    },

    getRestaurantWidth() {
      const floor = this.$el.querySelector(".floor-restaurants");
      const floorWidth = floor.getBoundingClientRect().width - 40;
      var width = floorWidth * 0.22; // width - padding
      width = (width > 49 ? 49 : width) + 5; // width + marging
      const perRow = Math.floor(floorWidth / width);
      return { width, perRow };
    },

    floorInvisibleRestaurants(floor) {
      if (this.refAvailable) {
        const { perRow } = this.getRestaurantWidth();
        const restaurants = this.floorRestaurants(floor);
        const count =
          Math.ceil(restaurants.length / perRow) * perRow - restaurants.length;
        const list = [];
        for (let i = 0; i < count; i += 1) {
          list.push(i);
        }
        return list;
      }
    },

    floorStyle(floor) {
      var rows = 1;
      if (this.refAvailable && floor) {
        const { perRow } = this.getRestaurantWidth();
        const restaurants = this.floorRestaurants(floor);
        rows = Math.ceil(restaurants.length / perRow);
        if (!rows) {
          rows = 1;
        }
      }
      return {
        height: rows * 61 + "px"
      };
    }
  },

  mounted() {
    this.refAvailable = true;
  }
};
</script>
<style lang="scss">
.building {
  width: 100%;
  bottom: 0;
}

.floor {
  position: relative;
  height: 100%;
  display: flex;

  &--B0 {
    display: none;
  }

  &--bottom {
    height: 70px;
    line-height: 70px;
    color: #fff;
    font-size: 30px;

    .floor-content {
      flex: 1;
      justify-content: center;
      background-color: $color-silver-grey;
    }
  }
}

.floor-label {
  font-size: 16px;
  font-weight: 500;
  width: 26px;
  z-index: 1;
  left: 0;
  padding-left: 10px;
  line-height: 1.2;
}

.floor-content {
  display: flex;
  flex: 1;
  align-items: center;
  border-bottom: 5px solid $color-silver-grey;
}

.floor-restaurants {
  position: relative;
  z-index: 2;
  padding: 5px 20px 0;
  display: flex;
  flex-wrap: wrap;
  align-items: center;
  flex: 1;
  justify-content: space-between;
  height: 100%;
}

.floor-restaurant {
  flex: 1 1 22%;
  background-size: contain;
  background-repeat: no-repeat;
  background-position: center;
  padding: 3px;
  background-origin: content-box;
  border: 1px solid $color-primary-grey;
  margin-bottom: 5px;
  margin-right: 5px;
  max-width: 49px;

  &:before {
    content: "";
    display: block;
    padding-bottom: 100%;
  }

  &.invisible {
    opacity: 0;
  }
}

.floor-parking-item {
  background-color: #717789;
  background-image: url("/static/images/building/materials/ic-parking.svg");
}
</style>
